.586 
.model flat, stdcall
option casemap:none

	include windows.inc
	include user32.inc
	include kernel32.inc
	includelib user32.lib	
	includelib kernel32.lib
	includelib roak.lib

	read_memory				PROTO address:DWORD
	calculate_disk_size		PROTO cylinder_number:DWORD, head_number:DWORD, sector_number:DWORD
	RoakMemory				PROTO p1:DWORD, p2:DWORD	; from roak.lib
	wsprintfA 				PROTO C :DWORD, :VARARG
	wsprintf 				equ <wsprintfA>

.data
; procedure to get handles variables
	w_std_handle			DD 0
	r_std_handle			DD 0
; procedure to call roak thunk variables
	table_disk_0_address		DD 0
	table_disk_1_address		DD 0
; procedure to read memory variables
	memory_buffer			DB 100 dup(?)
; procedure to display number variables
	OUT_NUMBER				DD 0
	num_char_written			DD 0
	bytes_to_write			DB 0
; procedure to input number variables
	IN_NUMBER				DD 0
	num_char_read			DD 0
	bytes_to_read			DB 0
; procedure to calculate disk size variables
	size_buffy				DB 100 dup(?)
	drive_number			DD 0
; general message variables
	main_msg				DB 10, 13, 10, 13, "     This program looks at two hard disk parameter tables.", 10, 13
	cw_msg				DB 10, 13, 10, 13, "     Freehafer's 32 Bit Assemblly Windows 95/98/ME", 10, 13, "     Hard Disk Parameter Program Is Terminated!", 10, 13, 10, 13, "     (c)2002 INNIEA PUBLISHING COMPANY!  R", 153, 142, "K NOG!", 10, 13, 10, 13, "     Hit enter key to exit . . . "
	hit_msg				DB 10, 13, 10, 13, "     HIT ENTER KEY TO SEE NEXT HARD DRIVE PARAMETER TABLE . . .", 10, 13
	size_msg				DB 10, 13, 10, 13, "     This table is for hard disk %d.  Its size is %d gigabytes.", 0
	table_msg				DB 10, 13, "     WORD Maximum # of cylinders          %5.d."
						DB 10, 13, "     BYTE Maximum # of heads              %5.d."
						DB 10, 13, "     WORD Reduced current cylinder        %5.d."
						DB 10, 13, "     WORD Pre-compensation cylinder       %5.d."
						DB 10, 13, "     BYTE Maximum ECC burst length        %5.d."
						DB 10, 13, "     BYTE Control byte                    %5.d."
						DB 10, 13, "     BYTE Standard timeout value          %5.d."
						DB 10, 13, "     BYTE Formatting timeout value        %5.d."
						DB 10, 13, "     BYTE Timeout for checking drive      %5.d."
						DB 10, 13, "     WORD Cylinder number of landing zone %5.d."
						DB 10, 13, "     BYTE Number of sectors per track     %5.d."
						DB 10, 13, "     BYTE Not used                        %5.d.", 0

.code	
start:

	CALL get_handles					; get console handles
	invoke WriteConsole, w_std_handle, ADDR main_msg, sizeof main_msg, ADDR num_char_written, 0
	CALL roak_nog					; calls a thunk to get the addresses of two hard disk parameter tables
	invoke read_memory, table_disk_0_address	; read first hard disk parameter tables data area
	invoke WriteConsole, w_std_handle, ADDR hit_msg, sizeof hit_msg, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke read_memory, table_disk_1_address	; read second hard disk parameter tables data area
	invoke WriteConsole, w_std_handle, ADDR cw_msg, sizeof cw_msg, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ExitProcess, 0

;........................................................................
;*******************************PROCEDURES*******************************
;........................................................................
; procedure to get console handles
;........................................................................
get_handles proc
	invoke GetStdHandle, -11
	mov w_std_handle, EAX
	invoke GetStdHandle, -10
	mov r_std_handle, EAX
	ret
get_handles endp
;........................................................................
; procedure to call roak thunk		
;........................................................................
roak_nog proc
	LOCAL mem_address:DWORD
	LOCAL mem_pointer[50]:BYTE
	mov EBX, 0
do_roak_again:
	mov EAX, 104h					; 41h * 4 = 104h through 46h * 4 = 118h 
	add EAX, EBX
	mov mem_address, EAX
 	invoke RoakMemory, ADDR mem_address, ADDR mem_pointer[EBX]
	inc EBX
	.if (EBX < 50)
	jmp do_roak_again
	.endif
	mov AL, mem_pointer[0]				; hard disk 0
	mov BL, AL
	mov AL, mem_pointer[1]
	mov CX, 256
	mul CX
	add AL, BL
	and EAX, 1111111111111111b
	mov table_disk_0_address, EAX
	add table_disk_0_address, 0F0000h		; hard disk 0 starting address
	mov AL, mem_pointer[14h]			; hard disk 1
	mov BL, AL
	mov AL, mem_pointer[15h]
	mov CX, 256
	mul CX
	add AL, BL
	and EAX, 1111111111111111b
	mov table_disk_1_address, EAX
	add table_disk_1_address, 0F0000h		; hard disk 1 starting address
	mov EAX, 0
	ret
roak_nog endp
;........................................................................
; procedure to read hard disk parameter table memory
;........................................................................
read_memory proc	address:DWORD
	LOCAL COUNTER:DWORD
	push ESI
	push EDI
	lea EDI, memory_buffer
	mov EAX, address
	mov ESI, EAX
	mov COUNTER, 16
look_loop:
	mov AL, byte ptr [ESI]
	mov byte ptr [EDI], AL
	inc ESI
	inc EDI
	dec COUNTER
	.if (COUNTER > 0)
		jmp look_loop
	.endif
	pop EDI
	pop ESI
	CALL display_table
	ret
read_memory endp
;........................................................................
; procedure to display table
;........................................................................
display_table proc
	LOCAL cylinder_number:DWORD
	LOCAL head_number:DWORD
	LOCAL reduced_number:DWORD
	LOCAL precomp_number:DWORD
	LOCAL burst_number:DWORD
	LOCAL control_number:DWORD
	LOCAL standard_number:DWORD
	LOCAL format_number:DWORD
	LOCAL checking_number:DWORD
	LOCAL landing_number:DWORD
	LOCAL sector_number:DWORD
	LOCAL reserved_number:DWORD
	LOCAL message_buffer[1000]:BYTE

	mov AL, memory_buffer[1]
	mov CX, 256
	mul CX
	add AL, memory_buffer[0]
	and EAX, 1111111111111111b
	mov cylinder_number, EAX

	mov AL, memory_buffer[2]
	and EAX, 11111111b
	mov head_number, EAX

	mov AL, memory_buffer[4]
	mov CX, 256
	mul CX
	add AL, memory_buffer[3]
	and EAX, 1111111111111111b
	mov reduced_number, EAX

	mov AL, memory_buffer[6]
	mov CX, 256
	mul CX
	add AL, memory_buffer[5]
	and EAX, 1111111111111111b
	mov precomp_number, EAX

	mov AL, memory_buffer[7]
	and EAX, 11111111b
	mov burst_number, EAX

	mov AL, memory_buffer[8]
	and EAX, 11111111b
	mov control_number, EAX

	mov AL, memory_buffer[9]
	and EAX, 11111111b
	mov standard_number, EAX

	mov AL, memory_buffer[10]
	and EAX, 11111111b
	mov format_number, EAX

	mov AL, memory_buffer[11]
	and EAX, 11111111b
	mov checking_number, EAX

	mov AL, memory_buffer[13]
	mov CX, 256
	mul CX
	add AL, memory_buffer[12]
	and EAX, 1111111111111111b
	mov landing_number, EAX

	mov AL, memory_buffer[14]
	and EAX, 11111111b
	mov sector_number, EAX

	mov AL, memory_buffer[15]
	and EAX, 11111111b
	mov reserved_number, EAX

	invoke wsprintf, ADDR message_buffer, ADDR table_msg, cylinder_number, head_number, reduced_number, precomp_number, burst_number, control_number, standard_number, format_number, checking_number, landing_number, sector_number, reserved_number
	invoke WriteConsole, w_std_handle, ADDR message_buffer, EAX, ADDR num_char_written, 0
	invoke calculate_disk_size, cylinder_number, head_number, sector_number
	ret
display_table endp
;........................................................................
; procedure to calculate disk size
;........................................................................
calculate_disk_size proc cylinder_number:DWORD, head_number:DWORD, sector_number:DWORD
	mov EAX, cylinder_number
	mov ECX, head_number
	mul ECX
	mov ECX, 1000
	div ECX
	mov ECX, sector_number
	mul ECX
	mov ECX, 1000
	div ECX
	mov ECX, 512
	mul ECX
	mov ECX, 1000
	div ECX
	invoke wsprintf, ADDR size_buffy, ADDR size_msg, drive_number, EAX
	inc drive_number
	invoke WriteConsole, w_std_handle, ADDR size_buffy, sizeof size_buffy, ADDR num_char_written, 0
	ret
calculate_disk_size endp
;........................................................................
; procedure to display number
;........................................................................
output_number proc
	LOCAL COUNTER:DWORD
	push EAX
	push EBX
	push ECX
	push EDX
	mov EAX, OUT_NUMBER				; number to be displayed
	mov EBX, 10
	mov COUNTER, 0					; recalibrate counter
display_number_loop_next_divide:
	mov EDX, 0
	div EBX						; get next digit in EDX
	push EDX						; store digit 
	inc COUNTER
	cmp EAX, 0 
	jne display_number_loop_next_divide
display_number_out_loop:
	pop EDX						; retrieve digit
	add DL, 48						; make a character
	mov bytes_to_write[0], DL			; put character into address
	invoke WriteConsole, w_std_handle, ADDR bytes_to_write, 1, ADDR num_char_written, 0
	dec COUNTER
	.IF (COUNTER > 0)
	jmp display_number_out_loop
	.ENDIF
	pop EDX
	pop ECX
	pop EBX
	pop EAX
	ret
output_number endp
;........................................................................
; procedure to input number
;........................................................................
input_number proc
	push EAX
	push EBX
	push ECX
	push EDX
read_loop:
	mov EBX, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	mov AL, bytes_to_read
	cmp AL, 0            				; special character? are not 0 to 9
	jne not_special        				; if not - process character
	jmp short exit_read          			; finished
not_special:
	cmp al,'0'          				; compare character read to "0" (number?)
	jb exit_read					; if not, don't process
	cmp AL, '9'          				; compare character read to "9" (number?)
	ja exit_read					; if not, don't process 
	sub AL, '0'          				; convert character to number
	mov BL, AL           				; copy character read into BX
	mov EAX, IN_NUMBER				; hex number into AX
	mov ECX, 10
	mul ECX             				; one decimal position to the left
	mov IN_NUMBER, EAX				; store result back into memory
	add IN_NUMBER, EBX				; add current hex digit
	jmp short read_loop     	    	 	; read next character
exit_read:
	pop EDX
	pop ECX
	pop EBX
	pop EAX
	ret
input_number endp
;........................................................................
end start
